/* /////////////////////////////////////////////////////////////////////////////
 * File:        findfile_sequence_test.cpp
 *
 * Purpose:     Implementation file for the findfile_sequence_test project.
 *
 * Created:     24th April 2004
 * Updated:     25th April 2004
 *
 * Status:      Wizard-generated
 *
 * License:     (Licensed under the Synesis Software Open License)
 *
 *              Copyright (C) 1999-2004, Synesis Software Pty Ltd.
 *              All rights reserved.
 *
 *              www:        http://www.synesis.com.au/software
 *
 *              email:      software@synesis.com.au
 *
 *              This source code is placed into the public domain 2004
 *              by Synesis Software Pty Ltd. There are no restrictions
 *              whatsoever to your use of the software. 
 *
 *              This source code is provided by Synesis Software Pty Ltd "as is"
 *              and any warranties, whether expressed or implied, including, but
 *              not limited to, the implied warranties of merchantability and
 *              fitness for a particular purpose are disclaimed. In no event
 *              shall the Synesis Software Pty Ltd be liable for any direct,
 *              indirect, incidental, special, exemplary, or consequential
 *              damages (including, but not limited to, procurement of
 *              substitute goods or services; loss of use, data, or profits; or
 *              business interruption) however caused and on any theory of
 *              liability, whether in contract, strict liability, or tort
 *              (including negligence or otherwise) arising in any way out of
 *              the use of this software, even if advised of the possibility of
 *              such damage. 
 *
 *              Neither the name of Synesis Software Pty Ltd nor the names of
 *              any subdivisions, employees or agents of Synesis Software Pty
 *              Ltd, nor the names of any other contributors to this software
 *              may be used to endorse or promote products derived from this
 *              software without specific prior written permission. 
 *
 * ////////////////////////////////////////////////////////////////////////// */

#include <windows.h>
#include <stdio.h>
#if defined(__DMC__)
# include <iostream.h>
#else /* ? __DMC__ */
# include <iostream>

using std::cout;
using std::cerr;
using std::endl;
#endif /* __DMC__ */

#include <stlsoft.h>

#include <inetstl.h>
#include <inetstl_session.h>
#include <inetstl_connection.h>
#include <inetstl_filesystem_traits.h>
#include <inetstl_findfile_sequence.h>

#include <winstl_error_desc.h>

#include <string>
#include <vector>

#if defined(__DMC__)
#else /* ? __DMC__ */
using std::string;
using std::vector;
#endif /* __DMC__ */

/* ////////////////////////////////////////////////////////////////////////// */

/* ////////////////////////////////////////////////////////////////////////// */

void enumerate_dir_files(HINTERNET hconn, char const *dir, char const *pattern)
{
	inetstl::findfile_sequence	fs(hconn, dir, pattern, inetstl::findfile_sequence::files);

	inetstl::findfile_sequence::const_iterator	begin	=	fs.begin();
	inetstl::findfile_sequence::const_iterator	end		=	fs.end();

	for(; begin != end; ++begin)
	{
		printf("%s\n", (*begin).get_path());
	}
}

void enumerate_dir(HINTERNET hconn, char const *dir, char const *pattern)
{
	enumerate_dir_files(hconn, dir, pattern);

	typedef	vector<string>	dirs_t;

	dirs_t	dirs;

	{
		dirs.reserve(32);

		SetLastError(ERROR_SUCCESS);

		inetstl::findfile_sequence	fs(hconn, dir, "*", inetstl::findfile_sequence::directories);

		inetstl::findfile_sequence::const_iterator	begin	=	fs.begin();
		inetstl::findfile_sequence::const_iterator	end		=	fs.end();

		if(ERROR_SUCCESS != ::GetLastError())
		{
			printf("Failed to enumerate directories: %s\n", stlsoft::get_ptr(winstl::error_desc(::GetLastError())));
		}

		for(; begin != end; ++begin)
		{
			dirs.push_back((*begin).get_path());
		}
	}

	dirs_t::const_iterator	begin	=	dirs.begin();
	dirs_t::const_iterator	end		=	dirs.end();

	for(; begin != end; ++begin)
	{
		enumerate_dir(hconn, (*begin).c_str(), pattern);
	}

}

int main(int /* argc */, char ** /*argv*/)
{
#if 0
	::Sleep(100000);
#endif /* 0 */

	puts("findfile_sequence_test: " __STLSOFT_COMPILER_LABEL_STRING);

	try
	{
		/* . */
		char const			*host		=	"synesis.com.au";
		char const			*username	=	"syn3s1s";
		char const			*password	=	"kl66ym2a";
		inetstl::session	sess;
		inetstl::connection	conn(sess, host, INTERNET_INVALID_PORT_NUMBER, username, password, INTERNET_SERVICE_FTP, INTERNET_FLAG_PASSIVE, 0);

		enumerate_dir(conn, "/www/", "*");
	}
	catch(inetstl::internet_exception x)
	{
		printf("Exception caught: %s (%d, %s)\n", x.what(), x.error(), stlsoft::get_ptr(winstl::error_desc(x.error(), "wininet")));
	}

    return 0;
}

/* ////////////////////////////////////////////////////////////////////////// */
